/**************************************************************************/
/* AN12 ( アンケート回答明細 )                                            */
/*                                                                        */
/* Created : 2011/11/04 13:00:51                                          */
/**************************************************************************/
CREATE TABLE AN12 (
   NOKAITO   VARCHAR(10)                NOT NULL                  /* 1  回答番号       */
 , NOMEISAI  NUMERIC(9)     DEFAULT 0   NOT NULL                  /* 2  回答明細番号   */
 , USERID    VARCHAR(10)                NOT NULL                  /* 3  ユーザーID     */
 , CDANK     VARCHAR(10)                NOT NULL                  /* 4  アンケートC    */
 , CDSITSU   VARCHAR(10)                NOT NULL                  /* 5  質問C          */
 , KVAL      BLOB                                                 /* 6  回答値         */
 , KVALSCL   NUMERIC(1)     DEFAULT 0   NOT NULL                  /* 7  回答スケール値 */
 , KNAME     BLOB                                                 /* 8  回答名称       */
 , FGOTHER   VARCHAR(1)     DEFAULT '0' NOT NULL                  /* 9  その他         */
 , SUPOINT   NUMERIC(3)     DEFAULT 0   NOT NULL                  /* 10 得点           */
 , FGCORRECT VARCHAR(1)                                           /* 11 正解           */
 , UNIQ      BIGINT                     NOT NULL PRIMARY KEY      /* 12 ユニークキー   */
 , FGJ       VARCHAR(1)     DEFAULT '1' NOT NULL                  /* 13 状態フラグ     */
 , DYSET     VARCHAR(14)                                          /* 14 登録日時       */
 , PGSET     VARCHAR(10)                                          /* 15 作成PG         */
 , PGPSET    VARCHAR(10)                                          /* 16 作成親PG       */
 , USRSET    VARCHAR(10)                                          /* 17 作成社員       */
 , DYUPD     VARCHAR(14)                                          /* 18 更新日時       */
 , PGUPD     VARCHAR(10)                                          /* 19 更新PG         */
 , PGPUPD    VARCHAR(10)                                          /* 20 更新親PG       */
 , USRUPD    VARCHAR(10)                                          /* 21 更新者         */
);

CREATE SEQUENCE AN12S00 ;


CREATE TRIGGER AN12T00 FOR AN12
  BEFORE INSERT 
  AS BEGIN 
    NEW.UNIQ = GEN_ID( AN12S00,1 );
  END; 


